package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLScheduleContextNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLScheduleContextNode extends ISLScheduleNode  {
	
	/* @generated */
	protected ISLScheduleContextNode(long ptr) {
		/*** PROTECTED REGION ID(ISLScheduleContextNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLScheduleContextNode build(long ptr) {
		return new ISLScheduleContextNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLScheduleContextNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_context_get_context 
	 * 
	 * @generated
	**/
	public ISLSet getContextDomain() {
		/*** PROTECTED REGION ID(isl_schedule_node_context_get_context) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSet.build(ISLNative.isl_schedule_node_context_get_context(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLScheduleNodeVisitor visitor) {
		visitor.visitISLScheduleContextNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLScheduleContextNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
